Index: docs/tutorial02.txt
===================================================================
--- docs/tutorial02.txt	(revision 3882)
+++ docs/tutorial02.txt	(working copy)
@@ -354,7 +354,7 @@
 At top level, it displays all available years. Then it drills down to months
 and, ultimately, days.
 
-Now's also a good time to note that change lists give you free pagination. The
+Now is also a good time to note that change lists give you free pagination. The
 default is to display 50 items per page. Change-list pagination, search boxes,
 filters, date-hierarchies and column-header-ordering all work together like you
 think they should.
Index: docs/tutorial03.txt
===================================================================
--- docs/tutorial03.txt	(revision 3882)
+++ docs/tutorial03.txt	(working copy)
@@ -91,7 +91,7 @@
 The ``poll_id='23'`` part comes from ``(?P<poll_id>\d+)``. Using parenthesis around a
 pattern "captures" the text matched by that pattern and sends it as an argument
 to the view function; the ``?P<poll_id>`` defines the name that will be used to
-identify the matched pattern; and ``\d+`` is a regular experession to match a sequence of
+identify the matched pattern; and ``\d+`` is a regular expression to match a sequence of
 digits (i.e., a number).
 
 Because the URL patterns are regular expressions, there really is no limit on
Index: docs/api_stability.txt
===================================================================
--- docs/api_stability.txt	(revision 3882)
+++ docs/api_stability.txt	(working copy)
@@ -82,8 +82,8 @@
 That said, these APIs should *not* be considered stable, and are likely to
 change:
 
-   - `Forms and validation`_ will most likely be compeltely rewritten to
-     deemphasize Manipulators in favor of validation-aware models.
+   - `Forms and validation`_ will most likely be completely rewritten to
+     de-emphasize Manipulators in favor of validation-aware models.
 
    - `Serialization`_ is under heavy development; changes are likely.
 
@@ -91,7 +91,7 @@
      API changes may be necessary.
 
    - Generic relations will most likely be moved out of core and into the
-     content-types contrib package to avoid core dependacies on optional
+     content-types contrib package to avoid core dependancies on optional
      components.
 
    - The comments framework, which is yet undocumented, will likely get a complete
Index: docs/admin_css.txt
===================================================================
--- docs/admin_css.txt	(revision 3882)
+++ docs/admin_css.txt	(working copy)
@@ -82,7 +82,7 @@
 .help
     This is a custom class for blocks of inline help text explaining the
     function of form elements. It makes text smaller and gray, and when applied
-    to ``p`` elements withing ``.form-row`` elements (see Form Styles below),
+    to ``p`` elements within ``.form-row`` elements (see Form Styles below),
     it will offset the text to align with the form field. Use this for help
     text, instead of ``small quiet``. It works on other elements, but try to
     put the class on a ``p`` whenever you can.
Index: docs/faq.txt
===================================================================
--- docs/faq.txt	(revision 3882)
+++ docs/faq.txt	(working copy)
@@ -499,7 +499,7 @@
 How do I add database-specific options to my CREATE TABLE statements, such as specifying MyISAM as the table type?
 ------------------------------------------------------------------------------------------------------------------
 
-We try to avoid adding special cases in the Django code to accomodate all the
+We try to avoid adding special cases in the Django code to accommodate all the
 database-specific options such as table type, etc. If you'd like to use any of
 these options, create an `SQL initial data file`_ that contains ``ALTER TABLE``
 statements that do what you want to do. The initial data files are executed in
Index: docs/testing.txt
===================================================================
--- docs/testing.txt	(revision 3882)
+++ docs/testing.txt	(working copy)
@@ -389,7 +389,7 @@
 
 When you run ``./manage.py test``, Django looks at the ``TEST_RUNNER``
 setting to determine what to do. By default, ``TEST_RUNNER`` points to ``django.test.simple.run_tests``. This method defines the default Django
-testing behaviour. This behaviour involves:
+testing behavior. This behavior involves:
 
 #. Performing global pre-test setup
 #. Creating the test database
@@ -435,7 +435,7 @@
 ``create_test_db(verbosity=1, autoclobber=False)``
     Creates a new test database, and run ``syncdb`` against it.
 
-    ``verbosity`` has the same behaviour as in the test runner.
+    ``verbosity`` has the same behavior as in the test runner.
 
     ``Autoclobber`` describes the behavior that will occur if a database with
     the same name as the test database is discovered. If ``autoclobber`` is False,
@@ -450,4 +450,4 @@
     Destroys the database with the name ``settings.DATABASE_NAME`` matching,
     and restores the value of ``settings.DATABASE_NAME`` to the provided name.
 
-    ``verbosity`` has the same behaviour as in the test runner.
+    ``verbosity`` has the same behavior as in the test runner.
Index: docs/forms.txt
===================================================================
--- docs/forms.txt	(revision 3882)
+++ docs/forms.txt	(working copy)
@@ -489,7 +489,7 @@
 test *and if the form submission contained data* for that field, all the
 validators for that field are called in turn. The emphasized portion in the
 last sentence is important: if a form field is not submitted (because it
-contains no data -- which is normal HTML behaviour), the validators are not
+contains no data -- which is normal HTML behavior), the validators are not
 run against the field.
 
 This feature is particularly important for models using
Index: docs/templates.txt
===================================================================
--- docs/templates.txt	(revision 3882)
+++ docs/templates.txt	(working copy)
@@ -1056,7 +1056,7 @@
 Takes an optional argument that is a variable containing the date to use as
 the comparison point (without the argument, the comparison point is *now*).
 For example, if ``blog_date`` is a date instance representing midnight on 1
-June 2006, and ``comment_date`` is a date instanace for 08:00 on 1 June 2006,
+June 2006, and ``comment_date`` is a date instance for 08:00 on 1 June 2006,
 then ``{{ comment_date|timesince:blog_date }}`` would return "8 hours".
 
 timeuntil
Index: docs/templates_python.txt
===================================================================
--- docs/templates_python.txt	(revision 3882)
+++ docs/templates_python.txt	(working copy)
@@ -817,7 +817,7 @@
 
 Another common type of template tag is the type that displays some data by
 rendering *another* template. For example, Django's admin interface uses custom
-template tags to display the buttons along the botton of the "add/change" form
+template tags to display the buttons along the bottom of the "add/change" form
 pages. Those buttons always look the same, but the link targets change depending
 on the object being edited -- so they're a perfect case for using a small
 template that is filled with details from the current object. (In the admin's